Whamcloud - gitweb
LU-12511 utils: Move utilies specific values out of Lustre UAPI headers
[fs/lustre-release.git] / lustre / tests / ost-pools.sh
1 #!/bin/bash
2 #
3 # Run select tests by setting ONLY, or as arguments to the script.
4 # Skip specific tests by setting EXCEPT.
5 #
6
7 ONLY=${ONLY:-"$*"}
8 ORIG_PWD=${PWD}
9
10 LUSTRE=${LUSTRE:-$(dirname $0)/..}
11 . $LUSTRE/tests/test-framework.sh
12 init_test_env $@
13 init_logging
14
15 ALWAYS_EXCEPT="$OST_POOLS_EXCEPT"
16 # bug number for skipped test: -
17 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
18
19 build_test_filter
20
21 check_and_setup_lustre
22
23 if ! combined_mgs_mds; then
24         do_facet mgs "mkdir -p $MOUNT"
25         zconf_mount $mgs_HOST $MOUNT $MOUNT_OPTS ||
26                 error "unable to mount $MOUNT on the MGS"
27 fi
28
29 DIR=${DIR:-$MOUNT}
30 assert_DIR
31
32 MAXFREE=${MAXFREE:-$((2000000 * OSTCOUNT))}
33
34 # OST pools tests
35 POOL=testpool
36 POOL2=${POOL2:-${POOL}2}
37 POOL3=${POOL3:-${POOL}3}
38 NON_EXISTANT_POOL=nonexistantpool
39 NON_EXISTANT_FS=nonexistantfs
40 INVALID_POOL=some_invalid_pool_name
41 TGT_COUNT=$OSTCOUNT
42 TGT_FIRST=$(printf %04x 0)
43 TGT_MAX=$(printf %04x $((TGT_COUNT-1)))
44 TGT_STEP=1
45 TGT_LIST=$(seq 0x$TGT_FIRST $TGT_STEP 0x$TGT_MAX)
46 TGT_LIST2=$(seq 0x$TGT_FIRST 2 0x$TGT_MAX)
47
48 TGT_ALL="$FSNAME-OST[$TGT_FIRST-$TGT_MAX/1]"
49 TGT_HALF="$FSNAME-OST[$TGT_FIRST-$TGT_MAX/2]"
50
51 TGT_UUID=$(for i in $TGT_LIST; do printf "$FSNAME-OST%04x_UUID " $i; done)
52 TGT_UUID2=$(for i in $TGT_LIST2; do printf "$FSNAME-OST%04x_UUID " $i; done)
53
54 create_dir() {
55         local dir=$1
56         local pool=$2
57         local count=${3:-"-1"}
58         local idx=$4
59
60         mkdir -p $dir
61         if [[ -n $idx ]]; then
62                 $LFS setstripe -c $count -p $pool -i $idx $dir
63         else
64                 $LFS setstripe -c $count -p $pool $dir
65         fi
66         [[ $? -eq 0 ]] || error "$LFS setstripe -p $pool $dir failed"
67         [[ "$($LFS getstripe --pool $dir)" == "$pool" ]] ||
68                 error "$dir not created in expected pool '$pool'"
69 }
70
71 create_file() {
72         local file=$1
73         local pool=$2
74         local count=${3:-"-1"}
75         local index=${4:-"-1"}
76         rm -f $file
77         $LFS setstripe -i $index -c $count -p $pool $file
78         [[ $? -eq 0 ]] || error "$LFS setstripe -p $pool $file failed"
79         [[ "$($LFS getstripe --pool $file)" == "$pool" ]] ||
80                 error "$file not created in '$pool'"
81 }
82
83 osts_in_pool() {
84         local pool=$1
85         local res
86         for i in $(list_pool $FSNAME.$pool |
87                 sed -e 's/_UUID$//;s/^.*-OST//'); do
88                 res="$res $(printf "%d" 0x$i)"
89         done
90         echo $res
91 }
92
93 check_dir_in_pool() {
94         local dir=$1
95         local pool=$2
96         local res=$($LFS getstripe --pool $dir)
97
98         [ -n "$res" ] || error "dir '$dir' not in any pool"
99
100         [ "$res" == "$pool" ] ||
101                 error "dir '$dir' in pool '$res' instead of '$pool'"
102 }
103
104 check_file_in_pool() {
105         local file="$1"
106         local pool=$2
107         local count=$3
108         local osts=$(osts_in_pool $pool)
109         local res=$($LFS getstripe --pool $file)
110
111         [ -n "$res" ] || error "file '$file' not in any pool"
112
113         [ "$res" == "$pool" ] ||
114                 error "file '$file' in pool '$res' instead of '$pool'"
115
116         local osts=$(osts_in_pool $2)
117         check_file_in_osts "$file" "$osts" $count
118 }
119
120 check_file_in_osts() {
121         local file=$1
122         local ost_list=${2:-$TGT_LIST}
123         local count=$3
124         local res=$($LFS getstripe $file | awk '/0x/ { print $1 }')
125         local i
126
127         for i in $res; do
128                 found=$(echo :$ost_list: | tr " " ":" | grep :$i:)
129                 if [[ "$found" == "" ]]; then
130                         echo "ost list: $ost_list"
131                         echo "striping: $res"
132                         $LFS getstripe -v $file
133                         error "$file not allocated from OSTs $ost_list."
134                 fi
135         done
136
137         local ost_count=$($LFS getstripe -c $file)
138         [[ -n "$count" ]] && [[ $ost_count -ne $count ]] &&
139                 error "$file stripe count $count expected; got $ost_count" &&
140                 return 1
141
142 }
143
144 check_file_not_in_pool() {
145         local file=$1
146         local pool=$2
147         local res=$($LFS getstripe --pool $file)
148
149         [ "$res" != "$pool" ] || error "File '$file' is in pool: $res"
150 }
151
152 check_dir_not_in_pool() {
153         local dir=$1
154         local pool=$2
155         local res=$($LFS getstripe --pool $dir)
156
157         [ "$res" != "$pool" ] || error "Dir '$dir' is in pool: $res"
158 }
159
160 drain_pool() {
161     pool=$1
162     wait_update $HOSTNAME "lctl get_param -n lov.$FSNAME-*.pools.$pool" "" ||
163         error "Failed to remove targets from pool: $pool"
164 }
165
166 add_pool() {
167         local pool=$1
168         local osts=$2
169         local tgt="${3}$(lctl get_param -n lov.$FSNAME-*.pools.$pool |
170                 sort -u | tr '\n' ' ')"
171
172         do_facet mgs lctl pool_add $FSNAME.$pool $osts
173         local RC=$?
174         [[ $RC -ne 0 ]] && return $RC
175
176         # wait for OSTs to be added to the pool
177         for mds_id in $(seq $MDSCOUNT); do
178                 local mdt_id=$((mds_id-1))
179                 local lodname=$FSNAME-MDT$(printf "%04x" $mdt_id)-mdtlov
180                 wait_update_facet mds$mds_id \
181                         "lctl get_param -n lod.$lodname.pools.$pool |
182                                 sort -u | tr '\n' ' ' " "$tgt" >/dev/null ||
183                         error "mds$mds_id:pool add failed $1; $2"
184         done
185         wait_update $HOSTNAME "lctl get_param -n lov.$FSNAME-*.pools.$pool |
186                 sort -u | tr '\n' ' ' " "$tgt" >/dev/null ||
187                 error "pool_add failed: $1; $2"
188         return $RC
189 }
190
191 create_pool_nofail() {
192         create_pool $FSNAME.$1
193         [[ $? -ne 0 ]] && error "Pool creation of $1 failed"
194         return 0
195 }
196
197 create_pool_fail() {
198         create_pool $FSNAME.$1
199         [[ $? -ne 0 ]] ||
200                 error "Pool creation of $1 succeeded; should have failed"
201         return 0
202 }
203
204 ost_pools_init() {
205         destroy_test_pools
206 }
207
208 # Initialization
209 remote_mds_nodsh && skip "remote MDS with nodsh"
210 remote_ost_nodsh && skip "remote OST with nodsh"
211 ost_pools_init
212
213 # Tests for new commands added
214 test_1a() {
215         create_pool_nofail p
216         destroy_pool p
217 }
218 run_test 1a "Create a pool with a 1 character pool name"
219
220 test_1b() {
221         create_pool_nofail ${POOL}12
222         destroy_pool ${POOL}12
223 }
224 run_test 1b "Create a pool with a 10 char pool name"
225
226 test_1c() {
227         create_pool_nofail ${POOL}1234567
228         destroy_pool ${POOL}1234567
229 }
230 run_test 1c "Create a pool with a 15 char pool name"
231
232 test_1d() {
233         create_pool_fail ${POOL}12345678
234 }
235 run_test 1d "Create a pool with a 16 char pool name; should fail"
236
237 test_1e() {
238         local pool_name="$POOL"
239         for ((i = 1; i <= 991; i++)); do pool_name=${pool_name}"o"; done
240         create_pool_fail $pool_name
241 }
242 run_test 1e "Create a pool with a 1000 char pool name; should fail"
243
244 test_1f() {
245         create_pool .$POOL
246         [[ $? -ne 0 ]] ||
247                 error "pool_new did not fail even though fs-name was missing"
248 }
249 run_test 1f "pool_new should fail if fs-name is missing"
250
251 test_1g() {
252         create_pool $POOL
253         [[ $? -ne 0 ]] ||
254                 error "pool_new did not fail even though fs-name was missing"
255 }
256 run_test 1g "pool_new should fail if fs-name is missing"
257
258 test_1h() {
259         create_pool ${FSNAME}.
260         [[ $? -ne 0 ]] ||
261                 error "pool_new did not fail even though pool name was missing"
262 }
263 run_test 1h "pool_new should fail if poolname is missing"
264
265 test_1i() {
266         create_pool .
267         [[ $? -ne 0 ]] ||
268                 error "pool_new did not fail even if pool/fs-name was missing"
269 }
270 run_test 1i "pool_new should fail if poolname and fs-name are missing"
271
272 test_1j() {
273         do_facet mgs lctl pool_new ${FSNAME},$POOL
274         [[ $? -ne 0 ]] ||
275                 error "pool_new did not fail even if poolname format was wrong"
276 }
277 run_test 1j "pool_new should fail if poolname format is wrong"
278
279 test_1k() {
280         do_facet mgs lctl pool_new ${FSNAME}/$POOL
281         [[ $? -ne 0 ]] ||
282                 error "pool_new did not fail even if poolname format was wrong"
283 }
284 run_test 1k "pool_new should fail if poolname format is wrong"
285
286 test_1m() {
287         create_pool_nofail $POOL2
288         create_pool ${FSNAME}.$POOL2
289         [[ $? -ne 0 ]] ||
290                 error "pool_new did not fail even though $POOL2 existed"
291         destroy_pool $POOL2
292 }
293 run_test 1m "pool_new did not fail even though $POOL2 existed"
294
295 test_1n() {
296         create_pool_nofail ${POOL}1234567
297
298         add_pool ${POOL}1234567 "OST0000" "$FSNAME-OST0000_UUID "
299         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
300         create_dir $POOL_ROOT ${POOL}1234567
301         dd if=/dev/zero of=$POOL_ROOT/file bs=1M count=100
302         RC=$?; [[ $RC -eq 0 ]] ||
303                 error "failed to write to $POOL_ROOT/file: $RC"
304         do_facet mgs lctl pool_remove $FSNAME.${POOL}1234567 OST0000
305         drain_pool ${POOL}1234567
306
307         destroy_pool ${POOL}1234567
308 }
309 run_test 1n "Pool with a 15 char pool name works well"
310
311 test_2a() {
312         destroy_pool $POOL
313
314         do_facet mgs lctl pool_add $FSNAME.$POOL $FSNAME-OST0000 2>/dev/null
315         [[ $? -ne 0 ]] ||
316                 error "pool_add did not fail even though $POOL did not exist"
317 }
318 run_test 2a "pool_add: non-existant pool $POOL"
319
320 test_2b() {
321         do_facet mgs lctl pool_add $FSNAME.${POOL}1234567890 \
322                 $FSNAME-OST0000 2>/dev/null
323         [[ $? -ne 0 ]] ||
324                 error "pool_add did not fail even though pool name was invalid."
325 }
326 run_test 2b "pool_add: Invalid pool name"
327
328 # Testing various combinations of OST name list
329 test_2c() {
330         local TGT
331         local RC
332
333         lctl get_param -n lov.$FSNAME-*.pools.$POOL 2>/dev/null
334         [[ $? -ne 0 ]] || destroy_pool $POOL
335
336         create_pool_nofail $POOL
337
338         # 1. OST0000
339         do_facet mgs lctl pool_add $FSNAME.$POOL OST0000
340         RC=$?; [[ $RC -eq 0 ]] ||
341                 error "pool_add failed. $FSNAME $POOL OST0000: $RC"
342         do_facet mgs lctl pool_remove $FSNAME.$POOL OST0000
343         drain_pool $POOL
344
345         # 2. $FSNAME-OST0000
346         do_facet mgs lctl pool_add $FSNAME.$POOL $FSNAME-OST0000
347         RC=$?; [[ $RC -eq 0 ]] ||
348                 error "pool_add failed. $FSNAME $POOL $FSNAME-OST0000: $RC"
349         do_facet mgs lctl pool_remove $FSNAME.$POOL $FSNAME-OST0000
350         drain_pool $POOL
351
352         # 3. $FSNAME-OST0000_UUID
353         do_facet mgs lctl pool_add $FSNAME.$POOL $FSNAME-OST0000_UUID
354         RC=$?; [[ $RC -eq 0 ]] ||
355                 error "pool_add failed. $FSNAME $POOL $FSNAME-OST0000_UUID: $RC"
356         do_facet mgs lctl pool_remove $FSNAME.$POOL $FSNAME-OST0000_UUID
357         drain_pool $POOL
358
359         # 4. $FSNAME-OST[0,1,2,3,]
360         TGT="$FSNAME-OST["
361         for i in $TGT_LIST; do TGT=${TGT}$(printf "%04x," $i); done
362         TGT="${TGT}]"
363         do_facet mgs lctl pool_add $FSNAME.$POOL $TGT
364         [[ $? -eq 0 ]] || error "pool_add failed. $FSNAME.$POOL $TGT. $RC"
365         do_facet mgs lctl pool_remove $FSNAME.$POOL $TGT
366         drain_pool $POOL
367
368         # 5. $FSNAME-OST[0-5/1]
369         do_facet mgs lctl pool_add $FSNAME.$POOL $TGT_ALL
370         RC=$?; [[ $RC -eq 0 ]] ||
371                 error "pool_add failed. $FSNAME $POOL" "$TGT_ALL $RC"
372         wait_update $HOSTNAME "lctl get_param -n lov.$FSNAME-*.pools.$POOL |
373                 sort -u | tr '\n' ' ' " "$TGT_UUID" ||
374                         error "Add to pool failed"
375         do_facet mgs lctl pool_remove $FSNAME.$POOL $TGT_ALL
376         drain_pool $POOL
377
378         destroy_pool $POOL
379 }
380 run_test 2c "pool_add: OST index combinations"
381
382 test_2d() {
383         local TGT
384         local RC
385
386         lctl get_param -n lov.$FSNAME-*.pools.$POOL 2>/dev/null
387         [[ $? -ne 0 ]] || destroy_pool $POOL
388
389         create_pool_nofail $POOL
390
391         TGT=$(printf "$FSNAME-OST%04x_UUID " $OSTCOUNT)
392         do_facet mgs lctl pool_add $FSNAME.$POOL $TGT
393         RC=$?; [[ $RC -ne 0 ]] ||
394                 error "pool_add succeeded for an OST ($TGT) that does not exist."
395
396         destroy_pool $POOL
397 }
398 run_test 2d "pool_add: OSTs that don't exist should be rejected"
399
400 test_2e() {
401         local TGT
402         local RC
403         local RESULT
404
405         $LCTL get_param -n lov.$FSNAME-*.pools.$POOL 2>/dev/null
406         [[ $? -ne 0 ]] || destroy_pool $POOL
407
408         create_pool_nofail $POOL
409
410         TGT="$FSNAME-OST0000_UUID"
411         do_facet mgs lctl pool_add $FSNAME.$POOL $TGT
412         wait_update_facet $SINGLEMDS \
413                 "lctl pool_list $FSNAME.$POOL | sed '1d'" "$TGT" ||
414                 error "Add $TGT to $FSNAME.$POOL failed"
415         RESULT=$(do_facet mgs \
416                 "LOCALE=C $LCTL pool_add $FSNAME.$POOL $TGT 2>&1")
417         RC=$?
418         echo $RESULT
419
420         [[ $RC -ne 0 ]] ||
421                 error "pool_add succeeded for an OST that was already in the pool."
422
423         [[ $(grep "already in pool" <<< $RESULT) ]] ||
424                 error "pool_add failed as expected but error message not as expected."
425
426         destroy_pool $POOL
427 }
428 run_test 2e "pool_add: OST already in a pool should be rejected"
429
430 test_3a() {
431         lctl get_param -n lov.$FSNAME-*.pools.$POOL 2>/dev/null
432         [[ $? -ne 0 ]] || destroy_pool $POOL
433
434         do_facet mgs \
435                 lctl pool_remove $FSNAME.$POOL $FSNAME-OST0000 2>/dev/null
436         [[ $? -ne 0 ]] ||
437                 error "pool_remove did not fail even though pool did not exist."
438 }
439 run_test 3a "pool_remove: non-existant pool"
440
441 test_3b() {
442         do_facet mgs \
443                 lctl pool_remove ${NON_EXISTANT_FS}.$POOL OST0000 2>/dev/null
444         [[ $? -ne 0 ]] ||
445                 error "pool_remove did not fail even though fsname did not exist."
446 }
447 run_test 3b "pool_remove: non-existant fsname"
448
449 test_3c() {
450         do_facet mgs lctl pool_remove $FSNAME.p1234567891234567890 \
451                 $FSNAME-OST0000 2>/dev/null
452         [[ $? -ne 0 ]] ||
453                 error "pool_remove did not fail even though pool name was invalid."
454 }
455 run_test 3c "pool_remove: Invalid pool name"
456
457 # Testing various combinations of OST name list
458 test_3d() {
459         lctl get_param -n lov.$FSNAME-*.pools.$POOL 2>/dev/null
460         [[ $? -ne 0 ]] || destroy_pool $POOL
461
462         create_pool_nofail $POOL
463         do_facet mgs lctl pool_add $FSNAME.$POOL OST0000
464         do_facet mgs lctl pool_remove $FSNAME.$POOL OST0000
465         [[ $? -eq 0 ]] || error "pool_remove failed. $FSNAME $POOL OST0000"
466         drain_pool $POOL
467
468         do_facet mgs lctl pool_add $FSNAME.$POOL $FSNAME-OST0000
469         do_facet mgs lctl pool_remove $FSNAME.$POOL $FSNAME-OST0000
470         [[ $? -eq 0 ]] || error "pool_remove failed. $FSNAME $POOL $FSNAME-OST0000"
471         drain_pool $POOL
472
473         do_facet mgs lctl pool_add $FSNAME.$POOL $FSNAME-OST0000_UUID
474         do_facet mgs lctl pool_remove $FSNAME.$POOL $FSNAME-OST0000_UUID
475         [[ $? -eq 0 ]] ||
476                 error "pool_remove failed. $FSNAME $POOL $FSNAME-OST0000_UUID"
477         drain_pool $POOL
478
479         add_pool $POOL $TGT_ALL "$TGT_UUID"
480         do_facet mgs lctl pool_remove $FSNAME.$POOL $TGT_ALL
481         [[ $? -eq 0 ]] || error "pool_remove failed. $FSNAME $POOL" $TGT_ALL
482         drain_pool $POOL
483
484         destroy_pool $POOL
485 }
486 run_test 3d "pool_remove: OST index combinations"
487
488 test_4a() {
489         lctl get_param -n lov.$FSNAME-*.pools.$POOL 2>/dev/null
490         [[ $? -ne 0 ]] || destroy_pool $POOL
491
492         do_facet mgs lctl pool_destroy $FSNAME.$POOL 2>/dev/null
493         [[ $? -ne 0 ]] ||
494                 error "pool_destroy did not fail even though pool did not exist."
495 }
496 run_test 4a "pool_destroy: non-existant pool"
497
498 test_4b() {
499         do_facet mgs lctl pool_destroy ${NON_EXISTANT_FS}.$POOL 2>/dev/null
500         [[ $? -ne 0 ]] ||
501                 error "pool_destroy did not fail even though filesystem did not exist."
502 }
503 run_test 4b "pool_destroy: non-existant fs-name"
504
505 test_4c() {
506         create_pool_nofail $POOL
507         add_pool $POOL "OST0000" "$FSNAME-OST0000_UUID "
508
509         do_facet mgs lctl pool_destroy ${FSNAME}.$POOL
510         [[ $? -ne 0 ]] || error "pool_destroy succeeded with a non-empty pool."
511         destroy_pool $POOL
512 }
513 run_test 4c "pool_destroy: non-empty pool"
514
515 sub_test_5() {
516         local LCMD=$1
517
518         $LCMD pool_list 2>/dev/null
519         [[ $? -ne 0 ]] ||
520                 error "pool_list did not fail even though fsname missing."
521
522         destroy_pool $POOL 2>/dev/null
523         destroy_pool $POOL2 2>/dev/null
524
525         create_pool_nofail $POOL
526         create_pool_nofail $POOL2
527         $LCMD pool_list $FSNAME
528         [[ $? -eq 0 ]] || error "pool_list $FSNAME failed."
529
530         do_facet mgs lctl pool_add $FSNAME.$POOL $TGT_ALL
531
532         $LCMD pool_list $FSNAME.$POOL
533         [[ $? -eq 0 ]] || error "pool_list $FSNAME.$POOL failed."
534
535         $LCMD pool_list ${NON_EXISTANT_FS} 2>/dev/null
536         [[ $? -ne 0 ]] ||
537                 error "pool_list did not fail for fsname $NON_EXISTANT_FS"
538
539         $LCMD pool_list ${FSNAME}.$NON_EXISTANT_POOL 2>/dev/null
540         [[ $? -ne 0 ]] ||
541                 error "pool_list did not fail for pool $NON_EXISTANT_POOL"
542
543         if [[ ! $(grep $SINGLEMDS <<< $LCMD) ]]; then
544                 echo $LCMD pool_list $DIR
545                 $LCMD pool_list $DIR
546                 [[ $? -eq 0 ]] || error "pool_list failed for $DIR"
547
548                 mkdir -p ${DIR}/d1
549                 $LCMD pool_list ${DIR}/d1
550                 [[ $? -eq 0 ]] || error "pool_list failed for ${DIR}/d1"
551         fi
552
553         rm -rf ${DIR}nonexistant
554         $LCMD pool_list ${DIR}nonexistant 2>/dev/null
555         [[ $? -ne 0 ]] ||
556                 error "pool_list did not fail for invalid mountpoint ${DIR}nonexistant"
557
558         destroy_pool $POOL
559         destroy_pool $POOL2
560 }
561
562 test_5a() {
563         # Issue commands from client
564         sub_test_5 $LFS
565 }
566 run_test 5a "lfs pool_list from client"
567
568 test_5b() {
569         sub_test_5 "do_facet $SINGLEMDS lctl"
570 }
571 run_test 5b "lctl pool_list from MDS"
572
573 test_6() {
574         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
575         local POOL_DIR=$POOL_ROOT/dir_tst
576         local POOL_FILE=$POOL_ROOT/file_tst
577
578         create_pool_nofail $POOL
579
580         do_facet $SINGLEMDS lctl pool_list $FSNAME
581         [[ $? -eq 0 ]] || error "pool_list $FSNAME failed."
582
583         add_pool $POOL $TGT_ALL "$TGT_UUID"
584
585         mkdir -p $POOL_DIR
586         $LFS setstripe -c -1 -p $POOL $POOL_DIR
587         [[ $? -eq 0 ]] || error "$LFS setstripe -p $POOL failed."
588         check_dir_in_pool $POOL_DIR $POOL
589
590         # If an invalid pool name is specified, the command should fail
591         $LFS setstripe -c 2 -p $INVALID_POOL $POOL_DIR 2>/dev/null
592         [[ $? -ne 0 ]] || error "setstripe to invalid pool did not fail."
593
594         # If the pool name does not exist, the command should fail
595         $LFS setstripe -c 2 -p $NON_EXISTANT_POOL $POOL_DIR 2>/dev/null
596         [[ $? -ne 0 ]] || error "setstripe to non-existant pool did not fail."
597
598         # lfs setstripe should work as before if a pool name is not specified.
599         $LFS setstripe -c -1 $POOL_DIR
600         [[ $? -eq 0 ]] || error "$LFS setstripe -c -1 $POOL_DIR failed."
601         $LFS setstripe -c -1 $POOL_FILE
602         [[ $? -eq 0 ]] || error "$LFS setstripe -c -1 $POOL_FILE failed."
603
604         # lfs setstripe should fail if a start index that is outside the
605         # pool is specified.
606         create_pool_nofail $POOL2
607         add_pool $POOL2 "OST0000" "$FSNAME-OST0000_UUID "
608         $LFS setstripe -i 1 -p $POOL2 $ROOT_POOL/$tfile 2>/dev/null
609         [[ $? -ne 0 ]] ||
610         error "$LFS setstripe with start index outside the pool did not fail."
611 }
612 run_test 6 "getstripe/setstripe"
613
614 helper_test_7a()
615 {
616         # Create a pool, stripe a directory and file with it
617         local pool=$1
618
619         pool_add $pool || error "pool_add failed"
620         pool_add_targets $pool 0 1 || error "pool_add_targets failed"
621
622         $LFS setstripe -c 1 $DIR/$tdir/testfile1 --pool "$pool" ||
623                 error "setstripe failed"
624         $LFS setstripe -c 1 $DIR/$tdir/testfile2 --pool "$FSNAME.$pool" ||
625                 error "setstripe failed"
626
627         mkdir $DIR/$tdir/testdir
628         $LFS setstripe -c 1 $DIR/$tdir/testdir  -p "$pool" ||
629                 error "setstripe failed"
630         $LFS setstripe -c 1 $DIR/$tdir/testdir  -p "$FSNAME.$pool" ||
631                 error "setstripe failed"
632
633         rm -f $DIR/$tdir/testfile1
634         rm -f $DIR/$tdir/testfile2
635         rmdir $DIR/$tdir/testdir
636
637         destroy_pool_int $FSNAME.$pool
638 }
639
640 test_7a()
641 {
642         [ $OSTCOUNT -lt 2 ] && skip_env "needs >= 2 OSTs"
643
644         mkdir -p $DIR/$tdir
645
646         # Generate pool with random name from 1 to 15 characters
647         for i in 1 9 15 ; do
648                 POOLNAME=$(echo $$$RANDOM$RANDOM |
649                            tr -dc 'a-zA-Z0-9' | fold -w $i |
650                            head -n 1)
651                 echo set poolname to $POOLNAME
652                 helper_test_7a $POOLNAME
653         done
654 }
655 run_test 7a "create various pool name"
656
657 test_7b()
658 {
659         # No fsname
660         create_pool qwerty
661         [ $? -ne 22 ] && error "can create a pool with no fsname"
662
663         # No pool name
664         create_pool $FSNAME.
665         [ $? -ne 22 ] && error "can create a pool with no name"
666
667         # Invalid character
668         create_pool $FSNAME.0123456789^bdef
669         [ $? -ne 22 ] && error "can create a pool with an invalid name"
670
671         # Too long
672         create_pool $FSNAME.0123456789abdefg
673         [ $? -ne 36 ] && error "can create a pool with a name too long"
674
675         return 0
676 }
677 run_test 7b "try to create pool name with invalid lengths or names"
678
679 test_7c()
680 {
681         [ $OSTCOUNT -lt 2 ] && skip_env "needs >= 2 OSTs"
682
683         mkdir -p $DIR/$tdir
684
685         # Create a pool with 15 letters
686         local pool=0123456789abcde
687         pool_add $pool || error "pool_add failed"
688         pool_add_targets $pool 0 1 || error "pool_add_targets failed"
689
690         # setstripe with the same pool name plus 1 letter
691         $LFS setstripe -c 1 $DIR/$tdir/testfile1 --pool "${pool}X" &&
692                 error "setstripe succedeed"
693
694         # setstripe with the same pool name minus 1 letter
695         $LFS setstripe -c 1 $DIR/$tdir/testfile1 --pool "${pool%?}" &&
696                 error "setstripe succedeed"
697
698         rm -f $DIR/$tdir/testfile1
699
700         destroy_pool_int $FSNAME.$pool
701 }
702 run_test 7c "create a valid pool name and setstripe with a bad one"
703
704 test_11() {
705         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
706
707         [[ $OSTCOUNT -le 1 ]] && skip_env "needs >= 2 OSTs"
708
709         create_pool_nofail $POOL
710         create_pool_nofail $POOL2
711
712         local start=$(printf %04x $((TGT_FIRST + 1)))
713         do_facet mgs lctl pool_add $FSNAME.$POOL2 \
714                 $FSNAME-OST[$start-$TGT_MAX/2]
715
716         add_pool $POOL $TGT_HALF "$TGT_UUID2"
717
718         create_dir $POOL_ROOT/dir1  $POOL
719         create_dir $POOL_ROOT/dir2  $POOL2
720
721         local numfiles=100
722         createmany -o $POOL_ROOT/dir1/$tfile $numfiles ||
723                 error "createmany $POOL_ROOT/dir1/$tfile failed!"
724
725         for file in $POOL_ROOT/dir1/*; do
726                 check_file_in_pool $file $POOL
727         done
728
729         createmany -o $POOL_ROOT/dir2/$tfile $numfiles ||
730                 error "createmany $POOL_ROOT/dir2/$tfile failed!"
731         for file in $POOL_ROOT/dir2/*; do
732                 check_file_in_pool $file $POOL2
733         done
734
735         rm -rf $POOL_ROOT/dir?
736
737         return 0
738 }
739 run_test 11 "OSTs in overlapping/multiple pools"
740
741 test_12() {
742         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
743
744         [[ $OSTCOUNT -le 2 ]] && skip_env "needs >=3 OSTs"
745
746         create_pool_nofail $POOL
747         create_pool_nofail $POOL2
748
749         local start=$(printf %04x $((TGT_FIRST + 1)))
750         do_facet mgs lctl pool_add $FSNAME.$POOL2 \
751                 $FSNAME-OST[$start-$TGT_MAX/2]
752
753         add_pool $POOL $TGT_HALF "$TGT_UUID2"
754
755         echo creating some files in $POOL and $POOL2
756
757         create_dir $POOL_ROOT/dir1  $POOL
758         create_dir $POOL_ROOT/dir2  $POOL2
759         create_file $POOL_ROOT/file1 $POOL
760         create_file $POOL_ROOT/file2 $POOL2
761
762         echo Checking the files created
763         check_file_in_pool $POOL_ROOT/file1 $POOL
764         check_file_in_pool $POOL_ROOT/file2 $POOL2
765
766         echo Changing the pool membership
767         do_facet mgs lctl pool_remove $FSNAME.$POOL $FSNAME-OST[$TGT_FIRST]
768         do_facet mgs lctl pool_list $FSNAME.$POOL
769         FIRST_UUID=$(echo $TGT_UUID | awk '{print $1}')
770         add_pool $POOL2 $FSNAME-OST[$TGT_FIRST] "$FIRST_UUID "
771         do_facet mgs lctl pool_list $FSNAME.$POOL2
772
773         echo Checking the files again
774         check_dir_in_pool $POOL_ROOT/dir1 $POOL
775         check_dir_in_pool $POOL_ROOT/dir2 $POOL2
776         check_file_in_osts $POOL_ROOT/file1 "$TGT_LIST2"
777         check_file_in_osts $POOL_ROOT/file2 "$(seq 0x$start 2 0x$TGT_MAX)"
778
779         echo Creating some more files
780         create_dir $POOL_ROOT/dir3 $POOL
781         create_dir $POOL_ROOT/dir4 $POOL2
782         create_file $POOL_ROOT/file3 $POOL
783         create_file $POOL_ROOT/file4 $POOL2
784
785         echo Checking the new files
786         check_file_in_pool $POOL_ROOT/file3 $POOL
787         check_file_in_pool $POOL_ROOT/file4 $POOL2
788
789         return 0
790 }
791 run_test 12 "OST Pool Membership"
792
793 test_13() {
794         [[ $OSTCOUNT -le 2 ]] && skip_env "needs >= 3 OSTs"
795
796         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
797         local numfiles=10
798         local count=3
799
800         create_pool_nofail $POOL
801         add_pool $POOL $TGT_ALL "$TGT_UUID"
802
803         create_dir $POOL_ROOT/dir1 $POOL -1
804         createmany -o $POOL_ROOT/dir1/$tfile $numfiles ||
805                 error "createmany $POOL_ROOT/dir1/$tfile failed!"
806         for file in $POOL_ROOT/dir1/*; do
807                 check_file_in_pool $file $POOL $OSTCOUNT
808         done
809
810         create_file $POOL_ROOT/dir1/file1 $POOL 1 $TGT_FIRST
811         create_file $POOL_ROOT/dir1/file2 $POOL 1 $((TGT_FIRST + 1))
812         create_file $POOL_ROOT/dir1/file3 $POOL 1 $((TGT_FIRST + 2))
813         check_file_in_osts $POOL_ROOT/dir1/file1 $((16#$TGT_FIRST))
814         check_file_in_osts $POOL_ROOT/dir1/file2 "$((TGT_FIRST + 1))"
815         check_file_in_osts $POOL_ROOT/dir1/file3 "$((TGT_FIRST + 2))"
816
817         create_dir $POOL_ROOT/dir2 $POOL $count
818         createmany -o $POOL_ROOT/dir2/$tfile- $numfiles ||
819                 error "createmany $POOL_ROOT/dir2/$tfile- failed!"
820         for file in $POOL_ROOT/dir2/*; do
821                 check_file_in_pool $file $POOL $count
822         done
823
824         create_dir $POOL_ROOT/dir3 $POOL $count $((TGT_FIRST + 1))
825         createmany -o $POOL_ROOT/dir3/$tfile- $numfiles ||
826                 error "createmany $POOL_ROOT/dir3/$tfile- failed!"
827         for file in $POOL_ROOT/dir3/*; do
828                 check_file_in_pool $file $POOL $count
829         done
830
831         create_dir $POOL_ROOT/dir4 $POOL 1
832         createmany -o $POOL_ROOT/dir4/$tfile- $numfiles ||
833                 error "createmany $POOL_ROOT/dir4/$tfile- failed!"
834         for file in $POOL_ROOT/dir4/*; do
835                 check_file_in_pool $file $POOL 1
836         done
837
838         create_dir $POOL_ROOT/dir5 $POOL 1 $((TGT_FIRST + 2))
839         createmany -o $POOL_ROOT/dir5/$tfile- $numfiles ||
840                 error "createmany $POOL_ROOT/dir5/$tfile- failed!"
841         for file in $POOL_ROOT/dir5/*; do
842                 check_file_in_pool $file $POOL 1
843         done
844
845         rm -rf $POOL_ROOT/dir[1-5]/
846
847         return 0
848 }
849 run_test 13 "Striping characteristics in a pool"
850
851 test_14() {
852         [[ $OSTCOUNT -le 2 ]] && skip_env "needs >= 3 OSTs"
853
854         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
855         local numfiles=100
856         local i
857
858         [ $OSTSIZE -gt $((MAXFREE / OSTCOUNT)) ] &&
859         skip_env "OST size $OSTSIZE is larger than $((MAXFREE / OSTCOUNT))"
860
861         create_pool_nofail $POOL
862         create_pool_nofail $POOL2
863
864         add_pool $POOL $TGT_HALF "$TGT_UUID2"
865         add_pool $POOL2 "OST0000" "$FSNAME-OST0000_UUID "
866
867         create_dir $POOL_ROOT/dir1 $POOL 1
868         create_file $POOL_ROOT/dir1/file $POOL 1
869         local ost=$($LFS getstripe -i $POOL_ROOT/dir1/file)
870         i=0
871         while [[ $i -lt $numfiles ]]; do
872                 ost=$((ost + 2))
873                 [[ $ost -gt $((16#$TGT_MAX)) ]] && ost=$TGT_FIRST
874
875                 # echo "Iteration: $i OST: $ost"
876                 create_file $POOL_ROOT/dir1/file${i} $POOL 1
877                 check_file_in_pool $POOL_ROOT/dir1/file${i} $POOL
878                 i=$((i + 1))
879         done
880
881         # Fill up OST0 until it is nearly full.
882         # Create 9 files of size OST0_SIZE/10 each.
883         create_dir $POOL_ROOT/dir2 $POOL2 1
884         $LFS df $POOL_ROOT/dir2
885         OST0_SIZE=$($LFS df $POOL_ROOT/dir2 | awk '/\[OST:0\]/ { print $4 }')
886         FILE_SIZE=$((OST0_SIZE/1024/10))
887         echo "Filling OST0 with 9 files of ${FILE_SIZE}MB in $POOL_ROOT/dir2"
888         i=1
889         while [[ $i -lt 10 ]]; do
890                 dd if=/dev/zero of=$POOL_ROOT/dir2/f${i} bs=1M count=$FILE_SIZE
891                 i=$((i + 1))
892         done
893         sleep 1 # get new statfs info
894         $LFS df $POOL_ROOT/dir2
895
896         # OST $TGT_FIRST is no longer favored; but it may still be used.
897         create_dir $POOL_ROOT/dir3 $POOL 1
898         create_file $POOL_ROOT/dir3/file $POOL 1
899         createmany -o $POOL_ROOT/dir3/$tfile- $numfiles ||
900                 error "createmany $POOL_ROOT/dir3/$tfile- failed!"
901         for file in $POOL_ROOT/dir3/*; do
902                 check_file_in_pool $file $POOL
903         done
904
905         rm -rf $POOL_ROOT
906
907         return 0
908 }
909 run_test 14 "Round robin and QOS striping within a pool"
910
911 test_15() {
912         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
913         local numfiles=100
914         local i=0
915
916         while [[ $i -lt $OSTCOUNT ]]; do
917                 create_pool_nofail $POOL${i}
918
919                 local tgt=$(printf "$FSNAME-OST%04x_UUID " $i)
920                 add_pool $POOL${i} "$FSNAME-OST[$(printf %04x $i)]" "$tgt"
921                 create_dir $POOL_ROOT/dir${i} $POOL${i}
922                 createmany -o $POOL_ROOT/dir$i/$tfile $numfiles ||
923                         error "createmany $POOL_ROOT/dir$i/$tfile failed!"
924
925                 for file in $POOL_ROOT/dir$i/*; do
926                         check_file_in_osts $file $i
927                 done
928
929                 i=$((i + 1))
930         done
931
932         return 0
933 }
934 run_test 15 "One directory per OST/pool"
935
936 test_16() {
937         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
938         local numfiles=10
939         local i=0
940
941         create_pool_nofail $POOL
942
943         add_pool $POOL $TGT_HALF "$TGT_UUID2"
944
945         local dir=$POOL_ROOT/$tdir
946         create_dir $dir $POOL
947
948         for i in $(seq 1 10); do
949                 dir=${dir}/dir${i}
950         done
951         mkdir -p $dir
952
953         createmany -o $dir/$tfile $numfiles ||
954                 error "createmany $dir/$tfile failed!"
955
956         for file in $dir/*; do
957                 check_file_in_pool $file $POOL
958         done
959
960         rm -rf $POOL_ROOT/$tdir
961
962         return 0
963 }
964 run_test 16 "Inheritance of pool properties"
965
966 test_17() {
967         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
968         local numfiles=10
969         local i=0
970
971         create_pool_nofail $POOL
972
973         add_pool $POOL $TGT_ALL "$TGT_UUID"
974
975         local dir=$POOL_ROOT/dir
976         create_dir $dir $POOL
977
978         createmany -o $dir/${tfile}1_ $numfiles ||
979                 error "createmany $dir/${tfile}1_ failed!"
980
981         for file in $dir/*; do
982                 check_file_in_pool $file $POOL
983         done
984
985         destroy_pool $POOL
986
987         createmany -o $dir/${tfile}2_ $numfiles ||
988                 error "createmany $dir/${tfile}2_ failed!"
989
990         rm -rf $dir
991         return 0
992 }
993 run_test 17 "Referencing an empty pool"
994
995 create_perf() {
996     local cdir=$1/d
997     local numsec=$2
998     local time
999
1000     mkdir -p $cdir
1001     sync
1002     wait_delete_completed >/dev/null # give pending IO a chance to go to disk
1003     stat=$(createmany -o $cdir/${tfile} -$numsec | tail -1)
1004     files=$(echo $stat | cut -f 2 -d ' ')
1005     echo $stat 1>&2
1006     unlinkmany $cdir/${tfile} $files > /dev/null
1007     sync
1008
1009     echo $files
1010 }
1011
1012 test_18() {
1013         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
1014         local numsec=15
1015         local iter=3
1016         local plaindir=$POOL_ROOT/plaindir
1017         local pooldir=$POOL_ROOT/pooldir
1018         local f1=0
1019         local f2=0
1020         local f3=0
1021         local diff
1022
1023         for i in $(seq 1 $iter); do
1024                 echo "Create performance, iteration $i, $numsec seconds x 3"
1025
1026                 local files1=$(create_perf $plaindir $numsec)
1027                 [[ $files1 -eq 0 ]] && error "Zero files created without pool"
1028                 f1=$((f1 + files1))
1029                 echo "iter $i: $files1 creates without pool"
1030
1031                 create_pool_nofail $POOL > /dev/null
1032                 add_pool $POOL $TGT_ALL "$TGT_UUID" > /dev/null
1033                 create_dir $pooldir $POOL
1034                 local files2=$(create_perf $pooldir $numsec)
1035                 [[ $files2 -eq 0 ]] && error "Zero files created with pool"
1036                 f2=$((f2 + files2))
1037                 echo "iter $i: $files2 creates with pool"
1038
1039                 destroy_pool $POOL > /dev/null
1040                 local files3=$(create_perf $pooldir $numsec)
1041                 [[ $files3 -eq 0 ]] &&
1042                         error "Zero files created with missing pool"
1043                 f3=$((f3 + files3))
1044                 echo "iter $i: $files3 creates with missing pool"
1045
1046                 echo
1047         done
1048
1049         echo Avg files created in $numsec seconds without pool: $((f1 / iter))
1050         echo Avg files created in $numsec seconds with pool: $((f2 / iter))
1051         echo Avg files created in $numsec seconds missing pool: $((f3 / iter))
1052
1053         # Set this high until we establish a baseline for what the degradation
1054         # is / should be
1055         max=30
1056
1057         diff=$((($f1 - $f2) * 100 / $f1))
1058         echo  "No pool / wide pool: $diff %."
1059         [ $diff -gt $max ] &&
1060                 error_ignore bz23408 "Degradation with wide pool is $diff% > $max%"
1061
1062         max=30
1063         diff=$((($f1 - $f3) * 100 / $f1))
1064         echo  "No pool / missing pool: $diff %."
1065         [ $diff -gt $max ] &&
1066                 error_ignore bz23408 "Degradation with wide pool is $diff% > $max%"
1067
1068         return 0
1069 }
1070 run_test 18 "File create in a directory which references a deleted pool"
1071
1072 test_19() {
1073         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
1074         local numfiles=12
1075         local dir1=$POOL_ROOT/dir1
1076         local dir2=$POOL_ROOT/dir2
1077         local i=0
1078
1079         create_pool_nofail $POOL
1080
1081         add_pool $POOL $TGT_HALF "$TGT_UUID2"
1082
1083         create_dir $dir1 $POOL
1084         createmany -o $dir1/${tfile} $numfiles ||
1085                 error "createmany $dir1/${tfile} failed!"
1086         for file in $dir1/*; do
1087                 check_file_in_pool $file $POOL
1088         done
1089
1090         mkdir -p $dir2
1091         createmany -o $dir2/${tfile} $numfiles ||
1092                 error "createmany $dir2/${tfile} failed!"
1093         for file in $dir2/*; do
1094                 check_file_not_in_pool $file $POOL
1095         done
1096
1097         rm -rf $dir1 $dir2
1098
1099         return 0
1100 }
1101 run_test 19 "Pools should not come into play when not specified"
1102
1103 test_20() {
1104         [[ $OSTCOUNT -ge 2 ]] || skip_env "needs >= 2 OSTs"
1105
1106         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
1107         local numfiles=12
1108         local dir1=$POOL_ROOT/dir1
1109         local dir2=$dir1/dir2
1110         local dir3=$dir1/dir3
1111         local i=0
1112         local TGT
1113
1114         create_pool_nofail $POOL
1115         create_pool_nofail $POOL2
1116
1117         add_pool $POOL $TGT_HALF "$TGT_UUID2"
1118
1119         local start=$(printf %04x $((TGT_FIRST + 1)))
1120         TGT=$(for i in $(seq 0x$start 2 0x$TGT_MAX); do \
1121                 printf "$FSNAME-OST%04x_UUID " $i; done)
1122         add_pool $POOL2 "$FSNAME-OST[$start-$TGT_MAX/2]" "$TGT"
1123
1124         create_dir $dir1 $POOL
1125         create_file $dir1/file1 $POOL2  # Should replace $dir1 pool with $POOL2
1126         create_dir $dir2 $POOL2
1127         touch $dir2/file2               # Should inherit $POOL2 from $dir2
1128         mkdir $dir3                     # Should inherit $POOL from $dir1
1129         $LFS setstripe -c 1 $dir3       # Should remain existing $POOL
1130         touch $dir3/file3               # Should inherit $POOL from $dir3
1131         $LFS setstripe -c 1 $dir2/file4 # Should inherit $POOL2 from dir2
1132         $LFS setstripe -S 64K $dir1/file5 # Should inderit $POOL from $dir1
1133
1134         check_file_in_pool $dir1/file1 $POOL2
1135         check_file_in_pool $dir2/file2 $POOL2
1136         check_dir_not_in_pool $dir3 $POOL2
1137         check_file_not_in_pool $dir3/file3 $POOL2
1138         check_file_not_in_pool $dir2/file4 $POOL
1139         check_file_not_in_pool $dir1/file5 $POOL2
1140
1141         if [ "$MDS1_VERSION" -ge $(version_code 2.10.54) ]; then
1142                 check_dir_in_pool $dir3 $POOL
1143                 check_file_in_pool $dir3/file3 $POOL
1144                 check_file_in_pool $dir2/file4 $POOL2
1145                 check_file_in_pool $dir1/file5 $POOL
1146         fi
1147
1148         rm -rf $dir1
1149
1150         return 0
1151 }
1152 run_test 20 "Different pools in a directory hierarchy."
1153
1154 test_21() {
1155         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
1156         [[ $OSTCOUNT -le 1 ]] && skip_env "needs >= 2 OSTs"
1157
1158         local numfiles=12
1159         local i=0
1160         local dir=$POOL_ROOT/dir
1161
1162         create_pool_nofail $POOL
1163
1164         add_pool $POOL $TGT_HALF "$TGT_UUID2"
1165
1166         create_dir $dir $POOL $OSTCOUNT
1167         create_file $dir/file1 $POOL $OSTCOUNT
1168         $LFS getstripe -v $dir/file1
1169         check_file_in_pool $dir/file1 $POOL
1170
1171         rm -rf $dir
1172
1173         return 0
1174 }
1175 run_test 21 "OST pool with fewer OSTs than stripe count"
1176
1177 add_loop() {
1178         local pool=$1
1179         local step=$2
1180
1181         echo loop for $pool
1182
1183         for c in $(seq 1 10); do
1184                 echo "Pool $pool, iteration $c"
1185                 do_facet mgs lctl pool_add $FSNAME.$pool \
1186                         OST[$TGT_FIRST-$TGT_MAX/$step] 2>/dev/null
1187                 local TGT_SECOND=$(printf %04x $((TGT_FIRST + $step)))
1188                 if [ $((16#$TGT_SECOND)) -le $((16#$TGT_MAX)) ]; then
1189                 do_facet mgs lctl pool_remove $FSNAME.$pool \
1190                         OST[$TGT_SECOND-$TGT_MAX/$step]
1191                 fi
1192         done
1193         echo loop for $pool complete
1194 }
1195
1196 test_22() {
1197         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
1198         [[ $OSTCOUNT -le 1 ]] && skip_env "needs >= 2 OSTs"
1199
1200         local numfiles=100
1201
1202         create_pool_nofail $POOL
1203         add_pool $POOL "OST0000" "$FSNAME-OST0000_UUID "
1204         create_pool_nofail $POOL2
1205         add_pool $POOL2 "OST0000" "$FSNAME-OST0000_UUID "
1206
1207         add_loop $POOL 1 &
1208         add_loop $POOL2 2 &
1209         sleep 5
1210         create_dir $POOL_ROOT $POOL
1211         createmany -o $POOL_ROOT/${tfile} $numfiles ||
1212                 error "createmany $POOL_ROOT/${tfile} failed!"
1213         wait
1214
1215         return 0
1216 }
1217 run_test 22 "Simultaneous manipulation of a pool"
1218
1219 test_23a() {
1220         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
1221         [[ $OSTCOUNT -le 1 ]] && skip_env "needs >= 2 OSTs"
1222
1223         mkdir -p $POOL_ROOT
1224         check_runas_id $RUNAS_ID $RUNAS_GID $RUNAS ||
1225                 skip_env "User $RUNAS_ID does not exist - skipping"
1226
1227         local i=0
1228         local TGT
1229         local BUNIT_SZ=1024  # min block quota unit(kB)
1230         local LIMIT=$((BUNIT_SZ * (OSTCOUNT + 1)))
1231         local dir=$POOL_ROOT/dir
1232         local file="$dir/$tfile-quota"
1233
1234         create_pool_nofail $POOL
1235
1236         local TGT=$(for i in $(seq 0x$TGT_FIRST 3 0x$TGT_MAX); do \
1237                 printf "$FSNAME-OST%04x_UUID " $i; done)
1238         add_pool $POOL "$FSNAME-OST[$TGT_FIRST-$TGT_MAX/3]" "$TGT"
1239         create_dir $dir $POOL
1240
1241         # XXX remove the interoperability code once we drop the old server
1242         #     ( < 2.3.50) support.
1243         if [ "$MDS1_VERSION" -lt $(version_code 2.3.50) ]; then
1244                 $LFS quotaoff -ug $MOUNT
1245                 $LFS quotacheck -ug $MOUNT
1246         else
1247                 if [[ $PERM_CMD == *"set_param -P"* ]]; then
1248                         do_facet mgs $PERM_CMD \
1249                                 osd-*.$FSNAME-OST*.quota_slave.enable=ug
1250                 else
1251                         do_facet mgs $PERM_CMD $FSNAME.quota.ost=ug
1252                 fi
1253                 sleep 5
1254         fi
1255
1256         $LFS setquota -u $RUNAS_ID -b $LIMIT -B $LIMIT $dir
1257         sleep 3
1258         $LFS quota -v -u $RUNAS_ID $dir
1259
1260         $LFS setstripe -c 1 -p $POOL $file
1261         chown $RUNAS_ID.$RUNAS_GID $file
1262         ls -l $file
1263
1264         # This does two "dd" runs to ensure that the quota failure is returned
1265         # to userspace when we check.  The first "dd" might otherwise complete
1266         # without error if it is only writing into cache.
1267         stat=$(LOCALE=C $RUNAS dd if=/dev/zero of=$file bs=$BUNIT_SZ \
1268                 count=$((BUNIT_SZ*2)) 2>&1)
1269         echo $stat | grep "Disk quota exceeded" > /dev/null
1270         if [ $? -eq 0 ]; then
1271                 $LFS quota -v -u $RUNAS_ID $dir
1272                 cancel_lru_locks osc
1273                 stat=$(LOCALE=C $RUNAS dd if=/dev/zero of=$file bs=$BUNIT_SZ \
1274                         count=$BUNIT_SZ seek=$((BUNIT_SZ*2)) 2>&1)
1275                 RC=$?
1276                 echo $stat
1277                 [[ $RC -eq 0 ]] && error "second dd did not fail."
1278                 echo $stat | grep "Disk quota exceeded" > /dev/null
1279                 [[ $? -eq 1 ]] && error "second dd did not fail with EDQUOT."
1280         else
1281                 log "first dd failed with EDQUOT."
1282         fi
1283         $LFS quota -v -u $RUNAS_ID $dir
1284 }
1285 run_test 23a "OST pools and quota"
1286
1287 test_23b() {
1288         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
1289         [[ $OSTCOUNT -le 1 ]] && skip_env "needs >= 2 OSTs"
1290
1291         mkdir -p $POOL_ROOT
1292         check_runas_id $RUNAS_ID $RUNAS_GID $RUNAS || {
1293                 skip_env "User $RUNAS_ID does not exist - skipping"
1294         }
1295
1296         local i=0
1297         local TGT
1298         local dir=$POOL_ROOT/dir
1299         local file="$dir/$tfile-quota"
1300
1301         create_pool_nofail $POOL
1302
1303         local TGT=$(for i in $(seq 0x$TGT_FIRST 3 0x$TGT_MAX); do \
1304                 printf "$FSNAME-OST%04x_UUID " $i; done)
1305         add_pool $POOL "$FSNAME-OST[$TGT_FIRST-$TGT_MAX/3]" "$TGT"
1306         create_dir $dir $POOL
1307
1308         local maxfree=$((1024 * 1024 * 30)) # 30G
1309         local AVAIL=$(lfs_df -p $POOL $dir | awk '/summary/ { print $4 }')
1310         [ $AVAIL -gt $maxfree ] &&
1311                 skip_env "Filesystem space $AVAIL is larger than " \
1312                         "$maxfree limit"
1313
1314         echo "OSTCOUNT=$OSTCOUNT, OSTSIZE=$OSTSIZE, AVAIL=$AVAIL"
1315         echo "MAXFREE=$maxfree, SLOW=$SLOW"
1316
1317         # XXX remove the interoperability code once we drop the old server
1318         #     ( < 2.3.50) support.
1319         if [ "$MDS1_VERSION" -lt $(version_code 2.3.50) ]; then
1320                 $LFS quotaoff -ug $MOUNT
1321         else
1322                 if [[ $PERM_CMD == *"set_param -P"* ]]; then
1323                         do_facet mgs $PERM_CMD \
1324                                 osd-*.$FSNAME-OST*.quota_slave.enable=none
1325                 else
1326                         do_facet mgs $PERM_CMD $FSNAME.quota.ost=none
1327                 fi
1328                 sleep 5
1329         fi
1330
1331         chown $RUNAS_ID.$RUNAS_ID $dir
1332         i=0
1333         local RC=0
1334         local TOTAL=0 # KB
1335         local stime=$(date +%s)
1336         local stat
1337         local etime
1338         local elapsed
1339         local maxtime=300 # minimum speed: 5GB / 300sec ~= 17MB/s
1340         while [ $RC -eq 0 ]; do
1341                 i=$((i + 1))
1342                 stat=$(LOCALE=C $RUNAS2 dd if=/dev/zero of=${file}$i bs=1M \
1343                         count=$((5 * 1024)) 2>&1)
1344                 RC=$?
1345                 TOTAL=$((TOTAL + 1024 * 1024 * 5))
1346                 echo "[$i iteration] $stat"
1347                 echo "total written: $TOTAL"
1348
1349                 etime=$(date +%s)
1350                 elapsed=$((etime - stime))
1351                 echo "stime=$stime, etime=$etime, elapsed=$elapsed"
1352
1353                 if [ $RC -eq 1 ]; then
1354                         echo $stat | grep -q "Disk quota exceeded"
1355                         [[ $? -eq 0 ]] &&
1356                                 error "dd failed with EDQUOT with quota off"
1357
1358                         echo $stat | grep -q "No space left on device"
1359                         [[ $? -ne 0 ]] &&
1360                                 error "dd did not fail with ENOSPC"
1361                 elif [ $TOTAL -gt $AVAIL ]; then
1362                         error "dd didn't fail with ENOSPC ($TOTAL > $AVAIL)"
1363                 elif [ $i -eq 1 -a $elapsed -gt $maxtime ]; then
1364                         log "The first 5G write used $elapsed (> $maxtime) " \
1365                                 "seconds, terminated"
1366                         RC=1
1367                 fi
1368         done
1369
1370         df -h
1371         rm -rf $POOL_ROOT
1372 }
1373 run_test 23b "OST pools and OOS"
1374
1375 test_24() {
1376         [[ $OSTCOUNT -le 1 ]] && skip_env "needs >= 2 OSTs"
1377         [[ "$MDS1_VERSION" -ge $(version_code 2.8.56) ]] ||
1378                 skip "Need server version newer than 2.8.55"
1379
1380         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
1381         local numfiles=10
1382         local i=0
1383         local TGT
1384         local dir
1385         local res
1386
1387         create_pool_nofail $POOL
1388
1389         add_pool $POOL $TGT_ALL "$TGT_UUID"
1390
1391         create_dir $POOL_ROOT/dir1 $POOL $OSTCOUNT
1392
1393         mkdir $POOL_ROOT/dir2
1394         $LFS setstripe -p $POOL -S 65536 -i 0 -c 1 $POOL_ROOT/dir2 ||
1395                 error "$LFS setstripe $POOL_ROOT/dir2 failed"
1396
1397         mkdir $POOL_ROOT/dir3
1398         $LFS setstripe -S 65536 -i 0 -c 1 $POOL_ROOT/dir3 ||
1399                 error "$LFS setstripe $POOL_ROOT/dir3 failed"
1400
1401         mkdir $POOL_ROOT/dir4
1402
1403         for i in 1 2 3 4; do
1404                 dir=${POOL_ROOT}/dir${i}
1405                 local pool
1406                 local pool1
1407                 local count
1408                 local count1
1409                 local index
1410                 local size
1411                 local size1
1412
1413                 createmany -o $dir/${tfile} $numfiles ||
1414                         error "createmany $dir/${tfile} failed!"
1415                 pool=$($LFS getstripe --pool $dir)
1416                 index=$($LFS getstripe -i $dir)
1417                 size=$($LFS getstripe -S $dir)
1418                 count=$($LFS getstripe -c $dir)
1419
1420                 for file in $dir/*; do
1421                         if [ "$pool" != "" ]; then
1422                                 check_file_in_pool $file $pool
1423                         fi
1424                         pool1=$($LFS getstripe --pool $file)
1425                         count1=$($LFS getstripe -c $file)
1426                         size1=$($LFS getstripe -S $file)
1427                         [[ "$pool" != "$pool1" ]] &&
1428                                 error "Pool '$pool' not on $file:$pool1"
1429                         [[ "$count" != "$count1" ]] &&
1430                                 [[ "$count" != "-1" ]] &&
1431                                         error "Stripe count $count not on"\
1432                                                 "$file:$count1"
1433                         [[ "$count1" != "$OSTCOUNT" ]] &&
1434                                 [[ "$count" = "-1" ]] &&
1435                                         error "Stripe count $count1 not on"\
1436                                                 "$file:$OSTCOUNT"
1437                         [[ "$size" != "$size1" ]] && [[ "$size" != "0" ]] &&
1438                                 error "Stripe size $size not on $file:$size1"
1439                 done
1440         done
1441
1442         rm -rf $POOL_ROOT
1443
1444         return 0
1445 }
1446 run_test 24 "Independence of pool from other setstripe parameters"
1447
1448 test_25() {
1449         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
1450
1451         mkdir -p $POOL_ROOT
1452
1453         for i in $(seq 10); do
1454                 create_pool_nofail $POOL$i
1455                 do_facet mgs "lctl pool_add $FSNAME.$POOL$i OST0000; sync"
1456                 wait_update $HOSTNAME "lctl get_param -n \
1457                         lov.$FSNAME-*.pools.$POOL$i | sort -u |
1458                         tr '\n' ' ' " "$FSNAME-OST0000_UUID " >/dev/null ||
1459                                 error "pool_add failed: $1; $2"
1460
1461                 facet_failover $SINGLEMDS ||
1462                         error "failed to failover $SINGLEMDS"
1463                 wait_osc_import_state $SINGLEMDS ost FULL
1464                 clients_up
1465
1466                 wait_mds_ost_sync
1467                 # Veriy that the pool got created and is usable
1468                 df $POOL_ROOT > /dev/null
1469                 sleep 5
1470
1471                 # Make sure OST0 can be striped on
1472                 $LFS setstripe -i 0 -c 1 $POOL_ROOT/$tfile
1473                 local STR=$($LFS getstripe -i $POOL_ROOT/$tfile)
1474                 rm $POOL_ROOT/$tfile
1475                 if [[ "$STR" == "0" ]]; then
1476                         echo "Creating a file in pool$i"
1477                         create_file $POOL_ROOT/file$i $POOL$i || break
1478                         check_file_in_pool $POOL_ROOT/file$i $POOL$i || break
1479                 else
1480                         echo "OST 0 seems to be unavailable.  Try later."
1481                 fi
1482         done
1483
1484         rm -rf $POOL_ROOT
1485 }
1486 run_test 25 "Create new pool and restart MDS"
1487
1488 test_26() {
1489         [[ $OSTCOUNT -le 2 ]] && skip_env "needs >= 3 OSTs"
1490         local dev=$(mdsdevname ${SINGLEMDS//mds/})
1491         local POOL_ROOT=${POOL_ROOT:-$DIR/$tdir}
1492
1493         mkdir -p $POOL_ROOT
1494
1495         create_pool_nofail $POOL2
1496
1497         do_facet mgs "lctl pool_add $FSNAME.$POOL2 OST0000; sync"
1498         wait_update $HOSTNAME "lctl get_param -n \
1499                 lov.$FSNAME-*.pools.$POOL2 | sort -u |
1500                 grep $FSNAME-OST0000_UUID " "$FSNAME-OST0000_UUID" ||
1501                         error "pool_add failed: $1; $2"
1502
1503         do_facet mgs "lctl pool_add $FSNAME.$POOL2 OST0002; sync"
1504         wait_update $HOSTNAME "lctl get_param -n \
1505                 lov.$FSNAME-*.pools.$POOL2 | sort -u |
1506                 grep $FSNAME-OST0002_UUID" "$FSNAME-OST0002_UUID" ||
1507                         error "pool_add failed: $1; $2"
1508
1509         # Veriy that the pool got created and is usable
1510         df $POOL_ROOT
1511         echo "Creating files in $POOL2"
1512
1513         for ((i = 0; i < 10; i++)); do
1514                 #OBD_FAIL_MDS_OSC_CREATE_FAIL     0x147
1515                 #Fail OST0000 to ensure objects create on
1516                 #the other OST in the pool
1517                 do_facet $SINGLEMDS lctl set_param fail_loc=0x147
1518                 do_facet $SINGLEMDS lctl set_param fail_val=0
1519                 create_file $POOL_ROOT/file$i $POOL2 1 -1 || break
1520                 do_facet $SINGLEMDS lctl set_param fail_loc=0
1521                 check_file_in_pool $POOL_ROOT/file$i $POOL2 || break
1522         done
1523         rm -rf $POOL_ROOT
1524 }
1525 run_test 26 "Choose other OSTs in the pool first in the creation remedy"
1526
1527 test_27() {
1528         [[ $OSTCOUNT -le 1 ]] && skip_env "Need at least 2 OSTs"
1529
1530         local osts
1531         local pid
1532         local count=$OSTCOUNT
1533
1534         create_pool_nofail $POOL
1535         do_facet mgs lctl pool_add $FSNAME.$POOL $TGT_ALL
1536         wait_update_facet $SINGLEMDS \
1537                 "lctl pool_list $FSNAME.$POOL | wc -l" "$((OSTCOUNT + 1))" ||
1538                 error "MDS: pool_list $FSNAME.$POOL failed"
1539         osts=$(list_pool $FSNAME.$POOL)
1540         for ost in ${osts}; do
1541                 ((count--))
1542                 if [[ $count -eq 0 ]]; then
1543                         #define OBD_FAIL_OST_LIST_ASSERT    0x239
1544                         do_facet $SINGLEMDS \
1545                                 $LCTL set_param fail_loc=0x239 fail_val=10
1546                         list_pool $FSNAME.$POOL &
1547                         pid=$!
1548                         sleep 5
1549                         do_facet $SINGLEMDS $LCTL set_param fail_loc=0
1550                         do_facet mgs $LCTL pool_remove $FSNAME.$POOL $ost
1551                         wait $pid
1552                         do_facet $SINGLEMDS $LCTL set_param fail_val=0
1553                 else
1554                         do_facet mgs $LCTL pool_remove $FSNAME.$POOL $ost
1555                 fi
1556         done
1557         destroy_pool $POOL
1558 }
1559 run_test 27 "Race pool_list and pool_remove"
1560
1561 test_28() {
1562         create_pool_nofail $POOL
1563         create_pool_nofail $POOL2
1564         add_pool $POOL $TGT_ALL "$TGT_UUID"
1565         add_pool $POOL2 $TGT_ALL "$TGT_UUID"
1566
1567         start_full_debug_logging
1568         #$LFS setstripe -E 4M -c 1 -p $POOL -E 16M -c 2 $DIR/$tfile
1569         $LFS setstripe -c 1 -p $POOL $DIR/$tfile
1570         dd if=/dev/urandom of=$DIR/$tfile bs=1M count=1 seek=16
1571         local csum=$(cksum $DIR/$tfile)
1572         $LFS getstripe $DIR/$tfile
1573         local pool="$($LFS getstripe -p $DIR/$tfile)"
1574         [[ "$pool" == "$POOL" ]] ||
1575                 error "$tfile is in '$pool', not created on $POOL"
1576         $LFS_MIGRATE -y -p $POOL2 $DIR/$tfile ||
1577                 error "migrate $tfile to $POOL2 failed"
1578         $LFS getstripe $DIR/$tfile
1579         pool="$($LFS getstripe -p $DIR/$tfile)"
1580         [[ "$pool" == "$POOL2" ]] ||
1581                 error "$tfile is in '$pool', not migrated to $POOL2"
1582         local csum2=$(cksum $DIR/$tfile)
1583         [[ "$csum" == "$csum2" ]] || error "checksum error after migration"
1584         stop_full_debug_logging
1585 }
1586 run_test 28 "lfs_migrate with pool name"
1587
1588 cd $ORIG_PWD
1589
1590 complete $SECONDS
1591 destroy_test_pools $FSNAME
1592 if ! combined_mgs_mds; then
1593         zconf_umount $mgs_HOST $MOUNT
1594         do_facet mgs "rm -rf $MOUNT"
1595 fi
1596 check_and_cleanup_lustre
1597 exit_status